## pgloader 3.3.2+dfsg

=== Makefile ===
# pgloader build tool
APP_NAME   = pgloader
VERSION    = 3.3.2

# use either sbcl or ccl
CL	   = sbcl

# default to 4096 MB of RAM size in the image
DYNSIZE    = 4096

LISP_SRC   = $(wildcard src/*lisp)         \
             $(wildcard src/monkey/*lisp)  \
             $(wildcard src/utils/*lisp)   \
             $(wildcard src/parsers/*lisp) \
             $(wildcard src/pgsql/*lisp)   \
             $(wildcard src/sources/*lisp) \
             pgloader.asd

BUILDDIR   = build
LIBS       = $(BUILDDIR)/libs.stamp
QLDIR      = $(BUILDDIR)/quicklisp
MANIFEST   = $(BUILDDIR)/manifest.ql
LATEST     = $(BUILDDIR)/pgloader-latest.tgz
BUNDLENAME = pgloader-bundle-$(VERSION)
BUNDLEDIR  = $(BUILDDIR)/bundle/$(BUNDLENAME)
BUNDLE     = $(BUILDDIR)/$(BUNDLENAME).tgz

ifeq ($(OS),Windows_NT)
EXE           = .exe
COMPRESS_CORE = no
DYNSIZE       = 1024		# support for windows 32 bits
else
EXE =
endif

PGLOADER   = $(BUILDDIR)/bin/$(APP_NAME)$(EXE)
BUILDAPP_CCL  = $(BUILDDIR)/bin/buildapp.ccl$(EXE)
BUILDAPP_SBCL = $(BUILDDIR)/bin/buildapp.sbcl$(EXE)

ifeq ($(CL),sbcl)
BUILDAPP      = $(BUILDAPP_SBCL)
BUILDAPP_OPTS = --require sb-posix                      \
                --require sb-bsd-sockets                \
                --require sb-rotate-byte
CL_OPTS    = --noinform --no-sysinit --no-userinit
else
BUILDAPP   = $(BUILDAPP_CCL)
CL_OPTS    = --no-init
endif

ifeq ($(CL),sbcl)
COMPRESS_CORE ?= $(shell $(CL) --noinform \
                               --quit     \
                               --eval '(when (member :sb-core-compression cl:*features*) (write-string "yes"))')

endif

# note: on Windows_NT, we never core-compress; see above.
ifeq ($(COMPRESS_CORE),yes)
COMPRESS_CORE_OPT = --compress-core
endif

DEBUILD_ROOT = /tmp/pgloader

all: $(PGLOADER)

clean:
	rm -rf $(LIBS) $(QLDIR) $(MANIFEST) $(BUILDAPP) $(PGLOADER)

docs:
	ronn -roff pgloader.1.md

$(QLDIR)/local-projects/qmynd:
	git clone --depth 1 https://github.com/qitab/qmynd.git $@

$(QLDIR)/local-projects/cl-ixf:
	git clone --depth 1 https://github.com/dimitri/cl-ixf.git $@

$(QLDIR)/local-projects/cl-db3:
	git clone --depth 1 https://github.com/dimitri/cl-db3.git $@

$(QLDIR)/local-projects/cl-csv:
	git clone --depth 1 https://github.com/AccelerationNet/cl-csv.git $@

$(QLDIR)/setup.lisp:
	mkdir -p $(BUILDDIR)
	curl -o $(BUILDDIR)/quicklisp.lisp http://beta.quicklisp.org/quicklisp.lisp
	$(CL) $(CL_OPTS) --load $(BUILDDIR)/quicklisp.lisp                        \
             --load src/getenv.lisp                                               \
             --eval '(quicklisp-quickstart:install :path "$(BUILDDIR)/quicklisp" :proxy (getenv "http_proxy"))' \
             --eval '(quit)'

quicklisp: $(QLDIR)/setup.lisp ;

clones: $(QLDIR)/local-projects/cl-ixf \
        $(QLDIR)/local-projects/cl-db3 \
        $(QLDIR)/local-projects/cl-csv \
        $(QLDIR)/local-projects/qmynd ;

$(LIBS): $(QLDIR)/setup.lisp clones
	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp                 \
             --eval '(push "$(PWD)/" asdf:*central-registry*)'      \
             --eval '(ql:quickload "pgloader")'                     \
             --eval '(quit)'
	touch $@

libs: $(LIBS) ;

$(MANIFEST): $(LIBS)
	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp                \
             --eval '(ql:write-asdf-manifest-file "$(MANIFEST)")'  \
             --eval '(quit)'

manifest: $(MANIFEST) ;

$(BUILDAPP_CCL): $(QLDIR)/setup.lisp
	mkdir -p $(BUILDDIR)/bin
	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp               \
             --eval '(ql:quickload "buildapp")'                   \
             --eval '(buildapp:build-buildapp "$@")'              \
             --eval '(quit)'

$(BUILDAPP_SBCL): $(QLDIR)/setup.lisp
	mkdir -p $(BUILDDIR)/bin
	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp               \
             --eval '(ql:quickload "buildapp")'                   \
             --eval '(buildapp:build-buildapp "$@")'              \
             --eval '(quit)'

buildapp: $(BUILDAPP) ;

$(PGLOADER): $(MANIFEST) $(BUILDAPP) $(LISP_SRC)
	mkdir -p $(BUILDDIR)/bin
	$(BUILDAPP)      --logfile /tmp/build.log                \
                         $(BUILDAPP_OPTS)                        \
                         --sbcl $(CL)                            \
                         --asdf-path .                           \
                         --asdf-tree $(QLDIR)/local-projects     \
                         --manifest-file $(MANIFEST)             \
                         --asdf-tree $(QLDIR)/dists              \
                         --asdf-path .                           \
                         --load-system $(APP_NAME)               \
                         --load src/hooks.lisp                   \
                         --entry pgloader:main                   \
                         --dynamic-space-size $(DYNSIZE)         \
                         $(COMPRESS_CORE_OPT)                    \
                         --output $@.tmp
	# that's ugly, but necessary when building on Windows :(
	mv $@.tmp $@

pgloader: $(PGLOADER) ;

pgloader-standalone:
	$(BUILDAPP)    $(BUILDAPP_OPTS)                        \
                       --sbcl $(CL)                            \
                       --load-system $(APP_NAME)               \
                       --load src/hooks.lisp                   \
                       --entry pgloader:main                   \
                       --dynamic-space-size $(DYNSIZE)         \
                       $(COMPRESS_CORE_OPT)                    \
                       --output $(PGLOADER)
test: $(PGLOADER)
	$(MAKE) PGLOADER=$(realpath $(PGLOADER)) -C test regress

clean-bundle:
	rm -rf $(BUNDLEDIR)

$(BUNDLEDIR):
	mkdir -p $@
	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp                \
             --eval '(ql:bundle-systems (list "pgloader" "buildapp") :to "$@")' \
             --eval '(quit)'

$(BUNDLE): $(BUNDLEDIR)
	cp bundle/README.md $(BUNDLEDIR)
	sed -e s/%VERSION%/$(VERSION)/ < bundle/Makefile > $(BUNDLEDIR)/Makefile
	git archive --format=tar --prefix=pgloader-$(VERSION)/ master \
	     | tar -C $(BUNDLEDIR)/local-projects/ -xf -
	make QLDIR=$(BUNDLEDIR) clones
	tar -C build/bundle 		    \
            --exclude bin   		    \
            --exclude test/sqlite           \
            -czf $@ pgloader-bundle-$(VERSION)

bundle: $(BUNDLE)

test-bundle:
	$(MAKE) -C $(BUNDLEDIR) test


deb:
	# intended for use on a debian system
	mkdir -p $(DEBUILD_ROOT) && rm -rf $(DEBUILD_ROOT)/*
	rsync -Ca --exclude 'build'                      		  \
		  --exclude '.vagrant'                   		  \
		  --exclude 'test/sqlite-chinook.load'   		  \
		  --exclude 'test/sqlite'                		  \
		  --exclude 'test/data/2013_Gaz_113CDs_national.txt'      \
		  --exclude 'test/data/reg2013.dbf'      		  \
		  --exclude 'test/data/sakila-db.zip'    		  \
              ./ $(DEBUILD_ROOT)/
	cd $(DEBUILD_ROOT) && make -f debian/rules orig
	cd $(DEBUILD_ROOT) && debuild -us -uc -sa
	cp -a /tmp/pgloader_* /tmp/cl-pgloader* build/

rpm:
	# intended for use on a CentOS or other RPM based system
	mkdir -p $(DEBUILD_ROOT) && rm -rf $(DEBUILD_ROOT)
	rsync -Ca --exclude=build/* ./ $(DEBUILD_ROOT)/
	cd /tmp && tar czf $(HOME)/rpmbuild/SOURCES/pgloader-$(VERSION).tar.gz pgloader
	cd $(DEBUILD_ROOT) && rpmbuild -ba pgloader.spec
	cp -a $(HOME)/rpmbuild/SRPMS/*rpm build
	cp -a $(HOME)/rpmbuild/RPMS/x86_64/*rpm build

pkg:
	# intended for use on a MacOSX system
	mkdir -p $(DEBUILD_ROOT) && rm -rf $(DEBUILD_ROOT)/*
	mkdir -p $(DEBUILD_ROOT)/usr/local/bin/
	mkdir -p $(DEBUILD_ROOT)/usr/local/share/man/man1/
	cp ./pgloader.1 $(DEBUILD_ROOT)/usr/local/share/man/man1/
	cp ./build/bin/pgloader $(DEBUILD_ROOT)/usr/local/bin/
	pkgbuild --identifier org.tapoueh.pgloader \
	         --root $(DEBUILD_ROOT)            \
	         --version $(VERSION)              \
                 ./build/pgloader-$(VERSION).pkg

latest:
	git archive --format=tar --prefix=pgloader-$(VERSION)/ v$(VERSION) \
        | gzip -9 > $(LATEST)

check: test ;

.PHONY: test pgloader-standalone

=== bundle/Makefile ===
# pgloader build tool for bundle tarball
# only supports SBCL
CL = sbcl

APP_NAME   = pgloader
VERSION    = %VERSION%

ifeq ($(OS),Windows_NT)
EXE           = .exe
COMPRESS_CORE = no
DYNSIZE       = 1024		# support for windows 32 bits
else
DYNSIZE       = 4096
EXE =
endif

BUILDDIR   = bin
BUILDAPP   = $(BUILDDIR)/buildapp$(EXE)
PGLOADER   = ./bin/pgloader

SRCDIR = local-projects/pgloader-$(VERSION)

BUILDAPP_OPTS = --require sb-posix                      \
                --require sb-bsd-sockets                \
                --require sb-rotate-byte
CL_OPTS    = --noinform --no-sysinit --no-userinit

COMPRESS_CORE ?= $(shell $(CL) --noinform \
                               --quit     \
                               --eval '(when (member :sb-core-compression cl:*features*) (write-string "yes"))')

ifeq ($(COMPRESS_CORE),yes)
COMPRESS_CORE_OPT = --compress-core
endif

pgloader: $(PGLOADER) ;
buildapp: $(BUILDAPP) ;

$(BUILDAPP):
	mkdir -p $(BUILDDIR)
	$(CL) $(CL_OPTS) --load bundle.lisp                           \
             --eval '(asdf:load-system :buildapp)'                    \
             --eval '(buildapp:build-buildapp "$@")'                  \
             --eval '(quit)'

$(PGLOADER): $(BUILDAPP)
	$(BUILDAPP)      --logfile /tmp/pgloader-bundle-build.log     \
                         $(BUILDAPP_OPTS)                             \
                         --sbcl $(CL)                                 \
                         --asdf-tree .                                \
                         --load-system $(APP_NAME)                    \
                         --eval '(setf pgloader.params::*version-string* "$(VERSION)")' \
                         --load $(SRCDIR)/src/hooks.lisp              \
                         --entry pgloader:main                        \
                         --dynamic-space-size $(DYNSIZE)              \
                         $(COMPRESS_CORE_OPT)                         \
                         --output $@.tmp
	# that's ugly, but necessary when building on Windows :(
	mv $@.tmp $@

test: $(PGLOADER)
	$(MAKE) PGLOADER=$(realpath $(PGLOADER)) -C $(SRCDIR)/test regress

check: test ;

=== test/Makefile ===
TMPDIR ?= /tmp
TESTS = $(wildcard *.load)
OUT   = $(TESTS:.load=.out)

REMOTE = archive.load bossa-all.load bossa.load census-places.load dbf-zip.load
LOCAL  = $(filter-out $(REMOTE:.load=.out),$(OUT))
REGRESS= allcols.load 		    \
         csv-before-after.load 	    \
         csv-districts.load 	    \
         csv-parse-date.load 	    \
         csv-error.load 	    \
         csv-escape-mode.load 	    \
         csv-filename-pattern.load  \
         csv-header.load            \
         csv-json.load              \
         csv-keep-extra-blanks.load \
         csv-missing-col.load       \
         csv-non-printable.load     \
         csv-nulls.load             \
         csv-temp.load              \
         csv-trim-extra-blanks.load \
         csv.load 		    \
	 copy.load                  \
	 copy-hex.load              \
         dbf.load 		    \
         errors.load 		    \
         fixed.load 		    \
         fields-with-periods.load   \
         ixf.load 		    \
         overflow.load 		    \
         partial.load 		    \
         serial.load 		    \
         udc.load 		    \
         xzero.load

PGLOADER ?= ../build/bin/pgloader

regress: clean-out $(addprefix regress/out/, $(REGRESS:.load=.out)) ;

clean-out:
	rm -f regress/out/*

local: prepare $(LOCAL)

remote: prepare $(REMOTE:.load=.out)

all: prepare $(OUT)

prepare: bossa.sql sakila
	-dropdb -U postgres pgloader
	-dropdb -U postgres stocks
	-dropdb -U postgres ip4r
	-createdb -U postgres -O `whoami` pgloader
	-createdb -U postgres -O `whoami` stocks
	-createdb -U postgres -O `whoami` ip4r
	-psql -d pgloader -c 'create schema expected'
	-psql -U postgres -d pgloader -c 'create extension ip4r'
	-psql -U postgres -d ip4r -c 'create extension ip4r'
	-psql -d stocks -f bossa.sql

errors.out: errors.load
	-$(PGLOADER) $<
	@echo

nofile.out: nofile.load
	-$(PGLOADER) $<
	@echo

csv-hstore.out: csv-hstore.load
	@echo skipping $@

# sakila needs preparing a MySQL database too
$(TMPDIR)/sakila-db/sakila-schema.sql: data/sakila-db.zip
	rm -rf $(TMPDIR)/sakila-db
	unzip $< -d $(TMPDIR)

sakila: $(TMPDIR)/sakila-db/sakila-schema.sql
	-dropdb -U postgres sakila
	-createdb -U postgres -O `whoami` sakila
	-echo "DROP DATABASE sakila" | mysql -u root
	echo "SOURCE $(TMPDIR)/sakila-db/sakila-schema.sql" | mysql -u root
	echo "SOURCE $(TMPDIR)/sakila-db/sakila-data.sql"   | mysql -u root

sakila.out: sakila sakila.load
	-$(PGLOADER) sakila.load
	@echo

csv-districts-stdin.out: csv-districts-stdin.load
	cat  data/2013_Gaz_113CDs_national.txt | $(PGLOADER) $^

# General case where we do NOT expect any error
%.out: %.load
	$(PGLOADER) $<
	@echo

# Regression tests
regress/out/%.out: %.load
	#./regress.sh $(PGLOADER) $<
	$(PGLOADER) --regress $<
	touch $@

=== debian/changelog ===
pgloader (3.3.2+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * pgloader: Add Depends: libssl1.0.2, dlopen()ed at runtime.
    (Closes: #864309)

 -- Andreas Beckmann <anbe@debian.org>  Wed, 07 Jun 2017 12:19:48 +0200

pgloader (3.3.2+dfsg-1) unstable; urgency=medium

  * Fixes github issue 453 (Closes: #843555)
  * Maintenance release.

 -- Dimitri Fontaine <dim@tapoueh.org>  Sat, 03 Dec 2016 19:36:56 +0300

=== debian/control ===
Source: pgloader
Section: database
Priority: extra
Maintainer: Dimitri Fontaine <dim@tapoueh.org>
Uploaders: Christoph Berg <myon@debian.org>
Build-Depends: debhelper (>= 8.0.0), sbcl (>= 1.1.13), ruby-ronn, buildapp (>= 1.5), cl-asdf (>= 3.0.3), cl-log, cl-postmodern, cl-simple-date, cl-qmynd, cl-split-sequence, cl-unicode, cl-interpol, cl-csv, cl-fad, cl-lparallel, cl-esrap, cl-alexandria, cl-drakma, cl-flexi-streams, cl-usocket, cl-local-time, cl-command-line-arguments, cl-abnf, cl-db3, cl-py-configparser, cl-sqlite, cl-trivial-backtrace, cl-markdown, cl-md5, cl-asdf-finalizers, cl-asdf-system-connections, cl-cffi (>= 1:0.12.0), cl-ixf, gawk, cl-bordeaux-threads (>= 0.8.3), cl-metabang-bind, cl-mssql, cl-uuid, cl-trivial-utf-8, cl-quri, cl-utilities, cl-ppcre, tzdata
Standards-Version: 3.9.6
Homepage: https://github.com/dimitri/pgloader
Vcs-Git: https://github.com/dimitri/pgloader.git
Vcs-Browser: https://github.com/dimitri/pgloader

Package: pgloader
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, freetds-dev, libssl1.0.2
Description: extract, transform and load data into PostgreSQL
 pgloader imports data from different kind of sources and COPY it into
 PostgreSQL.
 .
 The command language is described in the manual page and allows one to
 describe where to find the data source, its format, and to describe data
 processing and transformation.
 .
 Supported source formats include CSV, fixed width flat files, dBase3 files
 (DBF), and SQLite and MySQL databases. In most of those formats, pgloader
 is able to auto-discover the schema and create the tables and the indexes
 in PostgreSQL. In the MySQL case it's possible to edit CASTing rules from
 the pgloader command directly.

Package: cl-pgloader
Architecture: all
Depends: ${misc:Depends}, cl-asdf (>= 3.0.3), cl-log, cl-postmodern, cl-simple-date, cl-qmynd, cl-split-sequence, cl-unicode, cl-interpol, cl-csv, cl-fad, cl-lparallel, cl-esrap, cl-alexandria, cl-drakma, cl-flexi-streams, cl-usocket, cl-local-time, cl-command-line-arguments, cl-abnf, cl-db3, cl-py-configparser, cl-sqlite, cl-trivial-backtrace, cl-markdown, cl-md5, cl-asdf-finalizers, cl-asdf-system-connections, cl-cffi (>= 1:0.12.0), cl-bordeaux-threads (>= 0.8.3), cl-metabang-bind, cl-uuid, cl-trivial-utf-8, cl-quri, cl-utilities, cl-ppcre
Description: extract, transform and load data into PostgreSQL
 pgloader imports data from different kind of sources and COPY it into
 PostgreSQL.
 .
 The command language is described in the manual page and allows one to
 describe where to find the data source, its format, and to describe data
 processing and transformation.
 .
 Supported source formats include CSV, fixed width flat files, dBase3 files
 (DBF), and SQLite and MySQL databases. In most of those formats, pgloader
 is able to auto-discover the schema and create the tables and the indexes
 in PostgreSQL. In the MySQL case it's possible to edit CASTing rules from
 the pgloader command directly.

## pgloader 3.4.1%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -3,15 +3,15 @@
 Priority: extra
 Maintainer: Dimitri Fontaine <dim@tapoueh.org>
 Uploaders: Christoph Berg <myon@debian.org>
-Build-Depends: debhelper (>= 8.0.0), sbcl (>= 1.1.13), ruby-ronn, buildapp (>= 1.5), cl-asdf (>= 3.0.3), cl-log, cl-postmodern, cl-simple-date, cl-qmynd, cl-split-sequence, cl-unicode, cl-interpol, cl-csv, cl-fad, cl-lparallel, cl-esrap, cl-alexandria, cl-drakma, cl-flexi-streams, cl-usocket, cl-local-time, cl-command-line-arguments, cl-abnf, cl-db3, cl-py-configparser, cl-sqlite, cl-trivial-backtrace, cl-markdown, cl-md5, cl-asdf-finalizers, cl-asdf-system-connections, cl-cffi (>= 1:0.12.0), cl-ixf, gawk, cl-bordeaux-threads (>= 0.8.3), cl-metabang-bind, cl-mssql, cl-uuid, cl-trivial-utf-8, cl-quri, cl-utilities, cl-ppcre, tzdata
-Standards-Version: 3.9.6
+Build-Depends: debhelper (>= 9.0.0), sbcl (>= 1.1.13), ruby-ronn, buildapp (>= 1.5), cl-asdf (>= 3.0.3), cl-log, cl-postmodern, cl-simple-date, cl-qmynd, cl-split-sequence, cl-unicode, cl-interpol, cl-csv, cl-fad, cl-lparallel, cl-esrap, cl-alexandria, cl-drakma, cl-flexi-streams, cl-usocket, cl-local-time, cl-command-line-arguments, cl-abnf, cl-db3, cl-py-configparser, cl-sqlite, cl-trivial-backtrace, cl-markdown, cl-md5, cl-asdf-finalizers, cl-asdf-system-connections, cl-cffi (>= 1:0.12.0), cl-ixf, gawk, cl-bordeaux-threads (>= 0.8.3), cl-metabang-bind, cl-mssql, cl-uuid, cl-trivial-utf-8, cl-quri, cl-utilities, cl-ppcre, tzdata
+Standards-Version: 3.9.8
 Homepage: https://github.com/dimitri/pgloader
 Vcs-Git: https://github.com/dimitri/pgloader.git
 Vcs-Browser: https://github.com/dimitri/pgloader
 
 Package: pgloader
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, freetds-dev, libssl1.0.2
+Depends: ${shlibs:Depends}, ${misc:Depends}, freetds-dev
 Description: extract, transform and load data into PostgreSQL
  pgloader imports data from different kind of sources and COPY it into
  PostgreSQL.

## pgloader 3.4.1+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # pgloader build tool
 APP_NAME   = pgloader
-VERSION    = 3.3.2
+VERSION    = 3.4.1
 
 # use either sbcl or ccl
 CL	   = sbcl
@@ -160,7 +160,7 @@
                        $(COMPRESS_CORE_OPT)                    \
                        --output $(PGLOADER)
 test: $(PGLOADER)
-	$(MAKE) PGLOADER=$(realpath $(PGLOADER)) -C test regress
+	$(MAKE) PGLOADER=$(realpath $(PGLOADER)) CL=$(CL) -C test regress
 
 clean-bundle:
 	rm -rf $(BUNDLEDIR)
@@ -230,4 +230,4 @@
 
 check: test ;
 
-.PHONY: test pgloader-standalone
+.PHONY: test pgloader-standalone docs

=== test/Makefile ===
--- 
+++ 
@@ -34,6 +34,11 @@
          xzero.load
 
 PGLOADER ?= ../build/bin/pgloader
+
+EXTRA_OPTS =
+ifneq (,$(findstring ccl,$(CL)))
+EXTRA_OPTS = --batch --heap-reserve 150g
+endif
 
 regress: clean-out $(addprefix regress/out/, $(REGRESS:.load=.out)) ;
 
@@ -96,5 +101,5 @@
 # Regression tests
 regress/out/%.out: %.load
 	#./regress.sh $(PGLOADER) $<
-	$(PGLOADER) --regress $<
+	$(PGLOADER) $(EXTRA_OPTS) --regress $<
 	touch $@

=== debian/changelog ===
pgloader (3.4.1+dfsg-1) unstable; urgency=medium

  * New release, bugfixes and new features

 -- Dimitri Fontaine <dim@tapoueh.org>  Thu, 06 Jul 2017 16:51:53 +0300

## pgloader 3.5.2

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # pgloader build tool
 APP_NAME   = pgloader
-VERSION    = 3.4.1
+VERSION    = 3.5.2
 
 # use either sbcl or ccl
 CL	   = sbcl
@@ -11,7 +11,9 @@
 LISP_SRC   = $(wildcard src/*lisp)         \
              $(wildcard src/monkey/*lisp)  \
              $(wildcard src/utils/*lisp)   \
+             $(wildcard src/load/*lisp)    \
              $(wildcard src/parsers/*lisp) \
+             $(wildcard src/pg-copy/*lisp) \
              $(wildcard src/pgsql/*lisp)   \
              $(wildcard src/sources/*lisp) \
              pgloader.asd
@@ -21,9 +23,12 @@
 QLDIR      = $(BUILDDIR)/quicklisp
 MANIFEST   = $(BUILDDIR)/manifest.ql
 LATEST     = $(BUILDDIR)/pgloader-latest.tgz
+
+BUNDLEDIST = 2018-04-30
 BUNDLENAME = pgloader-bundle-$(VERSION)
 BUNDLEDIR  = $(BUILDDIR)/bundle/$(BUNDLENAME)
 BUNDLE     = $(BUILDDIR)/$(BUNDLENAME).tgz
+BUNDLETESTD= $(BUILDDIR)/bundle/test
 
 ifeq ($(OS),Windows_NT)
 EXE           = .exe
@@ -65,10 +70,7 @@
 all: $(PGLOADER)
 
 clean:
-	rm -rf $(LIBS) $(QLDIR) $(MANIFEST) $(BUILDAPP) $(PGLOADER)
-
-docs:
-	ronn -roff pgloader.1.md
+	rm -rf $(LIBS) $(QLDIR) $(MANIFEST) $(BUILDAPP) $(PGLOADER) docs/_build
 
 $(QLDIR)/local-projects/qmynd:
 	git clone --depth 1 https://github.com/qitab/qmynd.git $@
@@ -98,9 +100,9 @@
         $(QLDIR)/local-projects/qmynd ;
 
 $(LIBS): $(QLDIR)/setup.lisp clones
-	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp                 \
-             --eval '(push "$(PWD)/" asdf:*central-registry*)'      \
-             --eval '(ql:quickload "pgloader")'                     \
+	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp                   \
+             --eval '(push "$(PWD)/" ql:*local-project-directories*)' \
+             --eval '(ql:quickload "pgloader")'                       \
              --eval '(quit)'
 	touch $@
 
@@ -164,12 +166,18 @@
 
 clean-bundle:
 	rm -rf $(BUNDLEDIR)
+	rm -rf $(BUNDLETESTD)/$(BUNDLENAME)/*
+
+$(BUNDLETESTD):
+	mkdir -p $@
 
 $(BUNDLEDIR):
 	mkdir -p $@
-	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp                \
-             --eval '(ql:bundle-systems (list "pgloader" "buildapp") :to "$@")' \
-             --eval '(quit)'
+	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp      \
+             --eval '(defvar *bundle-dir* "$@")'         \
+             --eval '(defvar *pwd* "$(PWD)/")'           \
+             --eval '(defvar *ql-dist* "$(BUNDLEDIST)")' \
+             --load bundle/ql.lisp
 
 $(BUNDLE): $(BUNDLEDIR)
 	cp bundle/README.md $(BUNDLEDIR)
@@ -180,9 +188,12 @@
 	tar -C build/bundle 		    \
             --exclude bin   		    \
             --exclude test/sqlite           \
-            -czf $@ pgloader-bundle-$(VERSION)
-
-bundle: $(BUNDLE)
+            -czf $@ $(BUNDLENAME)
+
+bundle: clean-bundle $(BUNDLE) $(BUNDLETESTD)
+	tar -C $(BUNDLETESTD) -xf $(BUNDLE)
+	make -C $(BUNDLETESTD)/$(BUNDLENAME)
+	$(BUNDLETESTD)/$(BUNDLENAME)/bin/pgloader --version
 
 test-bundle:
 	$(MAKE) -C $(BUNDLEDIR) test
@@ -193,11 +204,6 @@
 	mkdir -p $(DEBUILD_ROOT) && rm -rf $(DEBUILD_ROOT)/*
 	rsync -Ca --exclude 'build'                      		  \
 		  --exclude '.vagrant'                   		  \
-		  --exclude 'test/sqlite-chinook.load'   		  \
-		  --exclude 'test/sqlite'                		  \
-		  --exclude 'test/data/2013_Gaz_113CDs_national.txt'      \
-		  --exclude 'test/data/reg2013.dbf'      		  \
-		  --exclude 'test/data/sakila-db.zip'    		  \
               ./ $(DEBUILD_ROOT)/
 	cd $(DEBUILD_ROOT) && make -f debian/rules orig
 	cd $(DEBUILD_ROOT) && debuild -us -uc -sa
@@ -230,4 +236,4 @@
 
 check: test ;
 
-.PHONY: test pgloader-standalone docs
+.PHONY: test pgloader-standalone docs bundle

=== debian/changelog ===
pgloader (3.5.2-3) unstable; urgency=medium

  * Make cl-pgloader test depend on ca-certificates so the snakeoil
    certificate is recognized as a valid CA. (Needs the /etc/ssl/certs/*.0
    file.)

 -- Christoph Berg <christoph.berg@credativ.de>  Tue, 31 Jul 2018 16:24:03 +0200

pgloader (3.5.2-2) unstable; urgency=medium

  * Install pgloader.asd into correct location. (Closes: #857226)
  * Test cl-pgloader through sbcl --eval.
  * Skip building and manpage generation in arch-indep builds.

 -- Christoph Berg <myon@debian.org>  Tue, 03 Jul 2018 22:51:48 +0200

pgloader (3.5.2-1) unstable; urgency=medium

  * New upstream version.
  * All included test data has been verified as free, stop building a +dfsg
    tarball.
  * debian/source/options: Ignore changes in src/params.lisp (release vs
    non-release).
  * Enable SSL in src/hooks.lisp.
  * Run wrap-and-sort -st.
  * Add new B-D cl-mustache, cl-yason, cl-zs3, sync Depends to cl-pgloader.
  * Depend on the libssl version cl-plus-ssl depends on. (Closes: #864309)
  * Build and install new sphinx docs instead.
  * Build manpage using help2man.
  * Priority: optional, move cl-pgloader to Section: lisp.
  * Update S-V.
  * Add watch file.

 -- Christoph Berg <christoph.berg@credativ.de>  Tue, 03 Jul 2018 16:59:07 +0200

## pgloader 3.6.1

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # pgloader build tool
 APP_NAME   = pgloader
-VERSION    = 3.5.2
+VERSION    = 3.6.1
 
 # use either sbcl or ccl
 CL	   = sbcl
@@ -24,7 +24,7 @@
 MANIFEST   = $(BUILDDIR)/manifest.ql
 LATEST     = $(BUILDDIR)/pgloader-latest.tgz
 
-BUNDLEDIST = 2018-04-30
+BUNDLEDIST = 2019-01-07
 BUNDLENAME = pgloader-bundle-$(VERSION)
 BUNDLEDIR  = $(BUILDDIR)/bundle/$(BUNDLENAME)
 BUNDLE     = $(BUILDDIR)/$(BUNDLENAME).tgz
@@ -99,8 +99,11 @@
         $(QLDIR)/local-projects/cl-csv \
         $(QLDIR)/local-projects/qmynd ;
 
-$(LIBS): $(QLDIR)/setup.lisp clones
+$(LIBS): $(QLDIR)/setup.lisp
 	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp                   \
+             --eval '(push :pgloader-image *features*)'               \
+             --eval '(setf *print-circle* t *print-pretty* t)'        \
+             --eval '(ql:quickload "pgloader")'                       \
              --eval '(push "$(PWD)/" ql:*local-project-directories*)' \
              --eval '(ql:quickload "pgloader")'                       \
              --eval '(quit)'
@@ -141,8 +144,11 @@
                          --manifest-file $(MANIFEST)             \
                          --asdf-tree $(QLDIR)/dists              \
                          --asdf-path .                           \
+                         --load-system cffi                      \
+                         --load-system cl+ssl                    \
+                         --load-system mssql                     \
+                         --load src/hooks.lisp                   \
                          --load-system $(APP_NAME)               \
-                         --load src/hooks.lisp                   \
                          --entry pgloader:main                   \
                          --dynamic-space-size $(DYNSIZE)         \
                          $(COMPRESS_CORE_OPT)                    \
@@ -164,6 +170,12 @@
 test: $(PGLOADER)
 	$(MAKE) PGLOADER=$(realpath $(PGLOADER)) CL=$(CL) -C test regress
 
+save: ./src/save.lisp $(LISP_SRC)
+	$(CL) $(CL_OPTS) --load ./src/save.lisp
+
+check-saved: save
+	$(MAKE) PGLOADER=$(realpath $(PGLOADER)) CL=$(CL) -C test regress
+
 clean-bundle:
 	rm -rf $(BUNDLEDIR)
 	rm -rf $(BUNDLETESTD)/$(BUNDLENAME)/*
@@ -179,8 +191,12 @@
              --eval '(defvar *ql-dist* "$(BUNDLEDIST)")' \
              --load bundle/ql.lisp
 
-$(BUNDLE): $(BUNDLEDIR)
+$(BUNDLEDIR)/version.sexp: $(BUNDLEDIR)
+	echo "\"$(VERSION)\"" > $@
+
+$(BUNDLE): $(BUNDLEDIR) $(BUNDLEDIR)/version.sexp
 	cp bundle/README.md $(BUNDLEDIR)
+	cp bundle/save.lisp $(BUNDLEDIR)
 	sed -e s/%VERSION%/$(VERSION)/ < bundle/Makefile > $(BUNDLEDIR)/Makefile
 	git archive --format=tar --prefix=pgloader-$(VERSION)/ master \
 	     | tar -C $(BUNDLEDIR)/local-projects/ -xf -

=== test/Makefile ===
--- 
+++ 
@@ -11,6 +11,7 @@
          csv-error.load 	    \
          csv-escape-mode.load 	    \
          csv-filename-pattern.load  \
+         csv-guess.load             \
          csv-header.load            \
          csv-json.load              \
          csv-keep-extra-blanks.load \
@@ -34,6 +35,7 @@
          xzero.load
 
 PGLOADER ?= ../build/bin/pgloader
+PGSUPERUSER ?= postgres
 
 EXTRA_OPTS =
 ifneq (,$(findstring ccl,$(CL)))
@@ -52,16 +54,16 @@
 all: prepare $(OUT)
 
 prepare: bossa.sql sakila
-	-dropdb -U postgres pgloader
-	-dropdb -U postgres stocks
-	-dropdb -U postgres ip4r
-	-createdb -U postgres -O `whoami` pgloader
-	-createdb -U postgres -O `whoami` stocks
-	-createdb -U postgres -O `whoami` ip4r
-	-psql -d pgloader -c 'create schema expected'
-	-psql -U postgres -d pgloader -c 'create extension ip4r'
-	-psql -U postgres -d ip4r -c 'create extension ip4r'
-	-psql -d stocks -f bossa.sql
+	-dropdb -U $(PGSUPERUSER) pgloader
+	-dropdb -U $(PGSUPERUSER) stocks
+	-dropdb -U $(PGSUPERUSER) ip4r
+	createdb -U $(PGSUPERUSER) -O `whoami` pgloader
+	createdb -U $(PGSUPERUSER) -O `whoami` stocks
+	createdb -U $(PGSUPERUSER) -O `whoami` ip4r
+	psql -d pgloader -c 'create schema expected'
+	psql -U $(PGSUPERUSER) -d pgloader -c 'create extension ip4r'
+	psql -U $(PGSUPERUSER) -d ip4r -c 'create extension ip4r'
+	psql -d stocks -f bossa.sql
 
 errors.out: errors.load
 	-$(PGLOADER) $<
@@ -80,8 +82,8 @@
 	unzip $< -d $(TMPDIR)
 
 sakila: $(TMPDIR)/sakila-db/sakila-schema.sql
-	-dropdb -U postgres sakila
-	-createdb -U postgres -O `whoami` sakila
+	-dropdb -U $(PGSUPERUSER) sakila
+	-createdb -U $(PGSUPERUSER) -O `whoami` sakila
 	-echo "DROP DATABASE sakila" | mysql -u root
 	echo "SOURCE $(TMPDIR)/sakila-db/sakila-schema.sql" | mysql -u root
 	echo "SOURCE $(TMPDIR)/sakila-db/sakila-data.sql"   | mysql -u root
@@ -93,6 +95,15 @@
 csv-districts-stdin.out: csv-districts-stdin.load
 	cat  data/2013_Gaz_113CDs_national.txt | $(PGLOADER) $^
 
+ifneq (,$(findstring ccl,$(CL)))
+regress/out/dbf.out: dbf.load
+	@echo "Skipping $@, CCL doesn't have CP850 encoding"
+	touch $@
+else
+	$(PGLOADER) $(EXTRA_OPTS) --regress $<
+	touch $@
+endif
+
 # General case where we do NOT expect any error
 %.out: %.load
 	$(PGLOADER) $<
@@ -100,6 +111,5 @@
 
 # Regression tests
 regress/out/%.out: %.load
-	#./regress.sh $(PGLOADER) $<
 	$(PGLOADER) $(EXTRA_OPTS) --regress $<
 	touch $@

=== debian/changelog ===
pgloader (3.6.1-1) unstable; urgency=medium

  * New upstream version.
  * SSL is always enabled now, drop our patch.
  * Add B-D on python3-sphinx-rtd-theme.

 -- Christoph Berg <christoph.berg@credativ.de>  Mon, 21 Jan 2019 16:09:17 +0100

## pgloader 3.6.2

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # pgloader build tool
 APP_NAME   = pgloader
-VERSION    = 3.6.1
+VERSION    = 3.6.2
 
 # use either sbcl or ccl
 CL	   = sbcl
@@ -24,7 +24,7 @@
 MANIFEST   = $(BUILDDIR)/manifest.ql
 LATEST     = $(BUILDDIR)/pgloader-latest.tgz
 
-BUNDLEDIST = 2019-01-07
+BUNDLEDIST = 2020-02-18
 BUNDLENAME = pgloader-bundle-$(VERSION)
 BUNDLEDIR  = $(BUILDDIR)/bundle/$(BUNDLENAME)
 BUNDLE     = $(BUILDDIR)/$(BUNDLENAME).tgz
@@ -103,7 +103,6 @@
 	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp                   \
              --eval '(push :pgloader-image *features*)'               \
              --eval '(setf *print-circle* t *print-pretty* t)'        \
-             --eval '(ql:quickload "pgloader")'                       \
              --eval '(push "$(PWD)/" ql:*local-project-directories*)' \
              --eval '(ql:quickload "pgloader")'                       \
              --eval '(quit)'
@@ -173,7 +172,7 @@
 save: ./src/save.lisp $(LISP_SRC)
 	$(CL) $(CL_OPTS) --load ./src/save.lisp
 
-check-saved: save
+check-saved:
 	$(MAKE) PGLOADER=$(realpath $(PGLOADER)) CL=$(CL) -C test regress
 
 clean-bundle:

=== bundle/Makefile ===
--- 
+++ 
@@ -48,9 +48,12 @@
                          $(BUILDAPP_OPTS)                             \
                          --sbcl $(CL)                                 \
                          --asdf-tree .                                \
+                         --load-system cffi                           \
+                         --load-system cl+ssl                         \
+                         --load-system mssql                          \
+                         --load $(SRCDIR)/src/hooks.lisp              \
                          --load-system $(APP_NAME)                    \
                          --eval '(setf pgloader.params::*version-string* "$(VERSION)")' \
-                         --load $(SRCDIR)/src/hooks.lisp              \
                          --entry pgloader:main                        \
                          --dynamic-space-size $(DYNSIZE)              \
                          $(COMPRESS_CORE_OPT)                         \
@@ -61,4 +64,7 @@
 test: $(PGLOADER)
 	$(MAKE) PGLOADER=$(realpath $(PGLOADER)) -C $(SRCDIR)/test regress
 
+save:
+	sbcl --no-userinit --load ./save.lisp
+
 check: test ;

=== test/Makefile ===
--- 
+++ 
@@ -20,6 +20,7 @@
          csv-nulls.load             \
          csv-temp.load              \
          csv-trim-extra-blanks.load \
+         csv-using-sexp.load        \
          csv.load 		    \
 	 copy.load                  \
 	 copy-hex.load              \
@@ -33,6 +34,13 @@
          serial.load 		    \
          udc.load 		    \
          xzero.load
+
+# Those are not included in the tests because CCL doesn't have the cp866
+# encoding, and then PostgreSQL 9.6 lacks "create schema if not exists".
+#
+# dbf-memo.load
+# dbf-31.load
+# dbf-8b.load
 
 PGLOADER ?= ../build/bin/pgloader
 PGSUPERUSER ?= postgres

=== debian/changelog ===
pgloader (3.6.2-1) unstable; urgency=medium

  * New upstream version.
  * debian/tests/ssl: Add --debug to get backtraces.
  * debian/rules: Sync loaded systems with Makefile.
  * debian/rules: Print actual compiler log.
  * debian/rules: Skip dh_dwz like dh_strip as it fails on buster.
  * Bump required cl-db3 version to 20200212.
  * Note that we need cl-plus-ssl 20190204 or later.
  * Note that we need cl-csv 20180712 or later.
  * DH 13.

 -- Christoph Berg <myon@debian.org>  Tue, 14 Jul 2020 17:02:30 +0200

=== debian/control ===
Source: pgloader
Section: database
Priority: optional
Maintainer: Dimitri Fontaine <dim@tapoueh.org>
Uploaders: Christoph Berg <myon@debian.org>
Build-Depends:
 buildapp (>= 1.5),
 cl-abnf,
 cl-alexandria,
 cl-asdf (>= 3.0.3),
 cl-asdf-finalizers,
 cl-asdf-system-connections,
 cl-bordeaux-threads (>= 0.8.3),
 cl-cffi (>= 1:0.12.0),
 cl-command-line-arguments,
 cl-csv (>= 20180712),
 cl-db3 (>= 20200212),
 cl-drakma,
 cl-esrap,
 cl-fad,
 cl-flexi-streams,
 cl-interpol,
 cl-ixf,
 cl-local-time,
 cl-log,
 cl-lparallel,
 cl-markdown,
 cl-md5,
 cl-metabang-bind,
 cl-mssql,
 cl-mustache,
 cl-plus-ssl (>= 20190204),
 cl-postmodern,
 cl-ppcre,
 cl-py-configparser,
 cl-qmynd,
 cl-quri,
 cl-simple-date,
 cl-split-sequence,
 cl-sqlite,
 cl-trivial-backtrace,
 cl-trivial-utf-8,
 cl-unicode,
 cl-usocket,
 cl-utilities,
 cl-uuid,
 cl-yason,
 cl-zs3,
 debhelper-compat (= 13),
 gawk,
 help2man,
 python3-sphinx-rtd-theme,
 python3-sphinx,
 sbcl (>= 1.1.13),
 tzdata,
Standards-Version: 4.5.0
Homepage: https://github.com/dimitri/pgloader
Vcs-Git: https://github.com/dimitri/pgloader.git
Vcs-Browser: https://github.com/dimitri/pgloader

Package: pgloader
Architecture: any
Depends: freetds-dev, ${misc:Depends}, ${shlibs:Depends}, ${ssl:Depends}
Description: extract, transform and load data into PostgreSQL
 pgloader imports data from different kind of sources and COPY it into
 PostgreSQL.
 .
 The command language is described in the manual page and allows one to
 describe where to find the data source, its format, and to describe data
 processing and transformation.
 .
 Supported source formats include CSV, fixed width flat files, dBase3 files
 (DBF), and SQLite and MySQL databases. In most of those formats, pgloader
 is able to auto-discover the schema and create the tables and the indexes
 in PostgreSQL. In the MySQL case it's possible to edit CASTing rules from
 the pgloader command directly.

Package: cl-pgloader
Section: lisp
Architecture: all
Depends:
 cl-abnf,
 cl-alexandria,
 cl-asdf (>= 3.0.3),
 cl-asdf-finalizers,
 cl-asdf-system-connections,
 cl-bordeaux-threads (>= 0.8.3),
 cl-cffi (>= 1:0.12.0),
 cl-command-line-arguments,
 cl-csv,
 cl-db3 (>= 20200212),
 cl-drakma,
 cl-esrap,
 cl-fad,
 cl-flexi-streams,
 cl-interpol,
 cl-ixf,
 cl-local-time,
 cl-log,
 cl-lparallel,
 cl-markdown,
 cl-md5,
 cl-metabang-bind,
 cl-mssql,
 cl-mustache,
 cl-postmodern,
 cl-ppcre,
 cl-py-configparser,
 cl-qmynd,
 cl-quri,
 cl-simple-date,
 cl-split-sequence,
 cl-sqlite,
 cl-trivial-backtrace,
 cl-trivial-utf-8,
 cl-unicode,
 cl-usocket,
 cl-utilities,
 cl-uuid,
 cl-yason,
 cl-zs3,
 ${misc:Depends},
Description: extract, transform and load data into PostgreSQL
 pgloader imports data from different kind of sources and COPY it into
 PostgreSQL.
 .
 The command language is described in the manual page and allows one to
 describe where to find the data source, its format, and to describe data
 processing and transformation.
 .
 Supported source formats include CSV, fixed width flat files, dBase3 files
 (DBF), and SQLite and MySQL databases. In most of those formats, pgloader
 is able to auto-discover the schema and create the tables and the indexes
 in PostgreSQL. In the MySQL case it's possible to edit CASTing rules from
 the pgloader command directly.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

# make pgloader depend on the libssl package cl-plus-ssl depends on
LIBSSL := $(shell dpkg-query --showformat='$${Depends}' --show cl-plus-ssl | grep -o 'libssl[^ ]*')

BITS = $(shell dpkg-architecture -qDEB_BUILD_ARCH_BITS)
ifeq ($(BITS),32)
SIZE=1024
else
SIZE=4096
endif

# buildd provides a build environment where $HOME is not writable, but the
# CL compilers here will need to fill-in a per-user cache
export HOME = $(CURDIR)/debian/home

override_dh_auto_clean:
	dh_auto_clean
	rm -rf debian/home

override_dh_auto_build-indep:
	# do nothing

override_dh_auto_build-arch:
	mkdir -p build/bin
	mkdir -p $(HOME)
	buildapp --require sb-posix						\
		--require sb-bsd-sockets					\
		--load /usr/share/common-lisp/source/cl-asdf/build/asdf.lisp	\
		--asdf-path .							\
		--asdf-tree /usr/share/common-lisp/systems			\
		--load-system asdf-finalizers					\
		--load-system asdf-system-connections				\
		--load-system cffi						\
		--load-system cl+ssl						\
		--load-system mssql						\
		--load src/hooks.lisp						\
		--load-system pgloader						\
		--entry pgloader:main						\
		--dynamic-space-size $(SIZE)					\
		--compress-core							\
		--logfile buildapp.log						\
		--output build/bin/pgloader					\
			|| echo $$? > buildapp.fail
	cat buildapp.log
	test ! -f buildapp.fail
	$(MAKE) -C docs html

override_dh_auto_test:
	# do nothing

override_dh_strip override_dh_dwz:
	# do nothing, sbcl doesn't write any debug info

override_dh_installman-arch:
	mkdir -p debian/pgloader/usr/share/man/man1/
	PATH=debian/pgloader/usr/bin:$(PATH) \
	help2man --version-string $(DEB_VERSION_UPSTREAM) \
		--no-info \
		--name "extract, transform and load data into PostgreSQL" \
		pgloader > \
		debian/pgloader/usr/share/man/man1/pgloader.1

override_dh_gencontrol:
	dh_gencontrol -- -V"ssl:Depends=$(LIBSSL)"

%:
	dh $@

=== debian/watch ===
version=4
https://github.com/dimitri/pgloader/releases .*/v(.*).tar.gz

## pgloader 3.6.3

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # pgloader build tool
 APP_NAME   = pgloader
-VERSION    = 3.6.2
+VERSION    = 3.6.3
 
 # use either sbcl or ccl
 CL	   = sbcl

=== test/citus/Makefile ===
DATASET = companies campaigns ads clicks impressions geo_ips
CSV     = $(addsuffix .csv,$(DATASET))
DROP = DROP TABLE IF EXISTS companies, campaigns, ads, clicks, impressions, geo_ips

all: schema data ;

schema:
	psql --single-transaction -c "$(DROP)" -d hackathon
	psql --single-transaction -f company.sql -d hackathon

data: fetch
	psql -f copy.sql -d hackathon
	../../build/bin/pgloader ./data.load

fetch: $(CSV) ;

%.csv:
	curl -O https://examples.citusdata.com/mt_ref_arch/$@

.PHONY: schema data fetch

=== debian/changelog ===
pgloader (3.6.3-1ubuntu1) jammy; urgency=medium

  * d/p/force-libcrypto-reload.patch: force reloading cl+ssl::libcrypto.
    (LP: #1968594)

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Tue, 12 Apr 2022 14:44:38 -0300

pgloader (3.6.3-1build1) jammy; urgency=medium

  * No changes rebuild for cl-plus-ssl fixes (LP: #1960615).

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Mon, 11 Apr 2022 09:16:20 -0300

pgloader (3.6.3-1) unstable; urgency=medium

  * New upstream version.
  * Remove cl-pgloader, deprecated upstream.
  * debian/tests/ssl: Force md5 auth if cl-postmodern is too old.

 -- Christoph Berg <myon@debian.org>  Tue, 21 Dec 2021 10:09:53 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: pgloader
 Section: database
 Priority: optional
-Maintainer: Dimitri Fontaine <dim@tapoueh.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Dimitri Fontaine <dim@tapoueh.org>
 Uploaders: Christoph Berg <myon@debian.org>
 Build-Depends:
  buildapp (>= 1.5),
@@ -74,62 +75,3 @@
  is able to auto-discover the schema and create the tables and the indexes
  in PostgreSQL. In the MySQL case it's possible to edit CASTing rules from
  the pgloader command directly.
-
-Package: cl-pgloader
-Section: lisp
-Architecture: all
-Depends:
- cl-abnf,
- cl-alexandria,
- cl-asdf (>= 3.0.3),
- cl-asdf-finalizers,
- cl-asdf-system-connections,
- cl-bordeaux-threads (>= 0.8.3),
- cl-cffi (>= 1:0.12.0),
- cl-command-line-arguments,
- cl-csv,
- cl-db3 (>= 20200212),
- cl-drakma,
- cl-esrap,
- cl-fad,
- cl-flexi-streams,
- cl-interpol,
- cl-ixf,
- cl-local-time,
- cl-log,
- cl-lparallel,
- cl-markdown,
- cl-md5,
- cl-metabang-bind,
- cl-mssql,
- cl-mustache,
- cl-postmodern,
- cl-ppcre,
- cl-py-configparser,
- cl-qmynd,
- cl-quri,
- cl-simple-date,
- cl-split-sequence,
- cl-sqlite,
- cl-trivial-backtrace,
- cl-trivial-utf-8,
- cl-unicode,
- cl-usocket,
- cl-utilities,
- cl-uuid,
- cl-yason,
- cl-zs3,
- ${misc:Depends},
-Description: extract, transform and load data into PostgreSQL
- pgloader imports data from different kind of sources and COPY it into
- PostgreSQL.
- .
- The command language is described in the manual page and allows one to
- describe where to find the data source, its format, and to describe data
- processing and transformation.
- .
- Supported source formats include CSV, fixed width flat files, dBase3 files
- (DBF), and SQLite and MySQL databases. In most of those formats, pgloader
- is able to auto-discover the schema and create the tables and the indexes
- in PostgreSQL. In the MySQL case it's possible to edit CASTing rules from
- the pgloader command directly.

=== debian/tests/control ===
Depends: pgloader, ca-certificates, cl-postmodern, postgresql
Tests: ssl
Restrictions: allow-stderr, needs-root

## pgloader 3.6.6

=== debian/changelog ===
pgloader (3.6.6-1.pgdg21.10+1) impish-pgdg; urgency=medium

  * Rebuild for impish-pgdg.
  * No source changes.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Mon, 27 Jun 2022 11:03:00 +0200

pgloader (3.6.6-1) unstable; urgency=medium

  * New upstream version.
  * Run tests at build-time as well.

 -- Christoph Berg <myon@debian.org>  Mon, 27 Jun 2022 11:03:00 +0200

pgloader (3.6.4-1) unstable; urgency=medium

  * New upstream version.
  * debian/tests/testsuite: Run regression tests.

 -- Christoph Berg <myon@debian.org>  Fri, 24 Jun 2022 14:32:54 +0200

=== debian/rules ===
--- 
+++ 
@@ -49,7 +49,7 @@
 	$(MAKE) -C docs html
 
 override_dh_auto_test:
-	# do nothing
+	PATH=$(CURDIR)/build/bin:$(PATH) debian/tests/testsuite
 
 override_dh_strip override_dh_dwz:
 	# do nothing, sbcl doesn't write any debug info

## pgloader 3.6.7

=== Makefile ===
--- 
+++ 
@@ -1,12 +1,12 @@
 # pgloader build tool
 APP_NAME   = pgloader
-VERSION    = 3.6.3
+VERSION    = 3.6.7
 
 # use either sbcl or ccl
 CL	   = sbcl
 
-# default to 4096 MB of RAM size in the image
-DYNSIZE    = 4096
+# default to 16 GB of RAM size in the image
+DYNSIZE    = 16384
 
 LISP_SRC   = $(wildcard src/*lisp)         \
              $(wildcard src/monkey/*lisp)  \
@@ -24,7 +24,7 @@
 MANIFEST   = $(BUILDDIR)/manifest.ql
 LATEST     = $(BUILDDIR)/pgloader-latest.tgz
 
-BUNDLEDIST = 2020-02-18
+BUNDLEDIST = 2022-02-20
 BUNDLENAME = pgloader-bundle-$(VERSION)
 BUNDLEDIR  = $(BUILDDIR)/bundle/$(BUNDLENAME)
 BUNDLE     = $(BUILDDIR)/$(BUNDLENAME).tgz
@@ -70,7 +70,9 @@
 all: $(PGLOADER)
 
 clean:
-	rm -rf $(LIBS) $(QLDIR) $(MANIFEST) $(BUILDAPP) $(PGLOADER) docs/_build
+	rm -rf $(LIBS) $(QLDIR) $(MANIFEST) $(BUILDAPP) $(PGLOADER) \
+		buildapp.log build/bundle/* build/pgloader-bundle* build/quicklisp.lisp docs/_build
+	$(MAKE) -C test clean
 
 $(QLDIR)/local-projects/qmynd:
 	git clone --depth 1 https://github.com/qitab/qmynd.git $@
@@ -182,7 +184,7 @@
 $(BUNDLETESTD):
 	mkdir -p $@
 
-$(BUNDLEDIR):
+$(BUNDLEDIR): quicklisp
 	mkdir -p $@
 	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp      \
              --eval '(defvar *bundle-dir* "$@")'         \

=== debian/changelog ===
pgloader (3.6.7-1.pgdg20.04+1) focal-pgdg; urgency=medium

  * Rebuild for focal-pgdg.
  * Changes applied by generate-pgdg-source:
    + Using debhelper 12.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Sat, 13 Aug 2022 10:32:41 +0200

pgloader (3.6.7-1) unstable; urgency=medium

  * New upstream version:
  * Set SBCL dynamic space size to 16 GB on 64 bit architectures.
  * Improve documentation with command lines and defaults.
  * SBCL compiler notes should not be fatal to pgloader.

 -- Christoph Berg <myon@debian.org>  Sat, 13 Aug 2022 10:32:41 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: pgloader
 Section: database
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Dimitri Fontaine <dim@tapoueh.org>
+Maintainer: Dimitri Fontaine <dim@tapoueh.org>
 Uploaders: Christoph Berg <myon@debian.org>
 Build-Depends:
  buildapp (>= 1.5),
@@ -47,9 +46,10 @@
  cl-uuid,
  cl-yason,
  cl-zs3,
- debhelper-compat (= 13),
+ debhelper (>= 12),
  gawk,
  help2man,
+ postgresql-14-ip4r <!nocheck> | postgresql-ip4r <!nocheck>,
  python3-sphinx-rtd-theme,
  python3-sphinx,
  sbcl (>= 1.1.13),
